#include <Configuration.h>
#include <States/GameState/Entities/DynamicEntities/DynamicEntities.h>
#include <States/GameState/Entities/Pacman/Pacman.h>
#include <States/GameState/Entities/StaticEntities/StaticEntities.h>

Pacman::Pacman() : m_circle{ config::GAME_PACMAN_SIZE/2 } {
    m_circle.setFillColor(config::GAME_COLOR_PACMAN);
    m_circle.setOrigin(config::GAME_PACMAN_SIZE/2, config::GAME_PACMAN_SIZE/2);
}

void Pacman::move(const Room::Direction direction) {
    m_ptr_room->get_side(direction)->enter(this);
}

void Pacman::draw_into(sf::RenderWindow& window) const {
    window.draw(m_circle);
}

void Pacman::prepare_for_drawing() {
    m_circle.setPosition(m_ptr_room->get_position());
}

std::unique_ptr<IGameEvent> Pacman::visit(Food* ptr_food) {
    if (ptr_food->get_location() != this->get_location())
        return {};
    return std::make_unique<DeleteStaticEntity>(ptr_food);
}

std::unique_ptr<IGameEvent> Pacman::visit(Enemy* ptr_enemy) {
    if (ptr_enemy->get_location() != this->get_location())
        return {};
    return std::make_unique<LostGame>();
}
