#pragma once
#include <States/GameState/Entities/IEntity.h>
#include <States/GameState/Entities/IVisitor.h>

class Pacman final : public IEntity, public IVisitor {
public:
    Pacman();
    void move(Room::Direction direction);
    void draw_into(sf::RenderWindow& window) const override;
    void prepare_for_drawing() override;
    std::unique_ptr<IGameEvent> visit(Food* ptr_food) override;
    std::unique_ptr<IGameEvent> visit(Enemy* ptr_enemy) override;
private:
    sf::CircleShape m_circle;
};